//+------------------------------------------------------------------+
//|                                                       BBflat.mq4 |
//|                                                          by Raff |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Aqua
#property indicator_style1 2
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Lime

extern int period=9;
extern int shift=0;
extern int method=0;
extern int price=0;
extern double deviation=1.5;
extern string separator1 = "*** MA Settings ***";
extern string separator2 = "SMA=0, EMA=1, SMMA=2, LWMA=3";
extern int MAperiod=10;
extern int MAmode=0;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
     int limit, counted_bars=IndicatorCounted();
     double ima, std;
     if(counted_bars<0) return(-1);
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
     for(int i=0; i<limit; i++)
       {
	    ima=iMA(NULL,0,period,shift,method,price,i);
       std=deviation*iStdDev(NULL,0,period,shift,method,price,i);
		 ExtMapBuffer1[i]=0;
       ExtMapBuffer2[i]=std;
       ExtMapBuffer3[i]=-std;
       ExtMapBuffer4[i]=Close[i]-ima;
       }

   for(i=0; i<limit; i++)
      ExtMapBuffer5[i]=iMAOnArray(ExtMapBuffer4,Bars,MAperiod,0,MAmode,i);

//----
   return(0);
  }
//+------------------------------------------------------------------+