//+------------------------------------------------------------------+
//|                                                  2000Grimace.mq4 |
//|                                                        deuxmille |
//|                                         http://www.deuxmille.org |
//+------------------------------------------------------------------+
#property copyright "deuxmille"
#property link      "http://www.deuxmille.org"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Green
//---- input parameters
extern int       barsToProcess=10000;
extern int p=50;
double redbuffer0[];
double redbuffer1[];
double greenbuffer0[];
double greenbuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexBuffer(0,redbuffer0);
SetIndexBuffer(1,redbuffer1);
SetIndexBuffer(2,greenbuffer0);
SetIndexBuffer(3,greenbuffer1);
SetIndexStyle(0,2,0,3,Red);
SetIndexStyle(1,2,0,3,Red);
SetIndexStyle(2,2,0,3,Green);
SetIndexStyle(3,2,0,3,Green);
//SetIndexEmptyValue(0,0.0);
//SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted(),
       limit;

   if(counted_bars>0)
      counted_bars--;
   
   limit=Bars-counted_bars;
   
   if(limit>barsToProcess)
      limit=barsToProcess;
  
   for(int i=0;i<limit;i++)
   {
   if(iClose(NULL,0,i+1)>iOpen(NULL,0,i+1))
   {
     if(iClose(NULL,0,i)>=MathMin(iClose(NULL,0,i+1),iClose(NULL,0,i+2)))
     {
     redbuffer0[i]=iClose(NULL,0,i+1)-p*Point;
     redbuffer1[i]=iClose(NULL,0,i)-p*Point;
     }
     if(iClose(NULL,0,i)<MathMin(iClose(NULL,0,i+1),iClose(NULL,0,i+2)))
      {
      redbuffer0[i]=MathMin(iClose(NULL,0,i+1),iClose(NULL,0,i+2))-p*Point;
      redbuffer1[i]=iClose(NULL,0,i+1)-p*Point;
      greenbuffer0[i]=MathMin(iClose(NULL,0,i+1),iClose(NULL,0,i+2))-p*Point;
      greenbuffer1[i]=iClose(NULL,0,i)-p*Point;
      }
   }
  if(iClose(NULL,0,i+1)<iOpen(NULL,0,i+1))
   {
     if(iClose(NULL,0,i)<=MathMax(iClose(NULL,0,i+1),iClose(NULL,0,i+2)))
     {
     greenbuffer0[i]=iClose(NULL,0,i+1)-p*Point;
     greenbuffer1[i]=iClose(NULL,0,i)-p*Point;
     }
     if(iClose(NULL,0,i)>MathMax(iClose(NULL,0,i+1),iClose(NULL,0,i+2)))
      {
      greenbuffer0[i]=MathMax(iClose(NULL,0,i+1),iClose(NULL,0,i+2))-p*Point;
      greenbuffer1[i]=iClose(NULL,0,i+1)-p*Point;
      redbuffer0[i]=MathMax(iClose(NULL,0,i+1),iClose(NULL,0,i+2))-p*Point;
      redbuffer1[i]=iClose(NULL,0,i)-p*Point;
      }
   }
   
   
   }       
   
   
   
   return(0);
  }
//+------------------------------------------------------------------+