//+------------------------------------------------------------------+
//|                                                   ABHAFIBOEM.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property  indicator_chart_window

extern color UpColor = White;
extern color InColor = Aqua;
extern color DnColor = White;
 bool  InnerFibs = true;
double H, H28,H7,H6,H5,H24,H3,H2,H1,L1,L2,L3,L4,L5,L6,L7,L8,L;
double HiPrice, LoPrice, Range;
datetime StartTime;
extern bool  Fibolines = false;
int init()
{  
H=0; L=0;H28=0; H7=0; H6=0; H5=0; H24=0; H3=0; H2=0; H1=0; L1=0; L2=0; L3=0; L4=0; L5=0; L6=0; L7=0; L8=0;

   return(0);
}

int deinit()
{
ObjectDelete("H Label");
ObjectDelete("H Line");
ObjectDelete("WP Label");
ObjectDelete("WP Line");

ObjectDelete("H28 Label");
ObjectDelete("H28 Line");
ObjectDelete("H7 Label");
ObjectDelete("H7 Line");
ObjectDelete("H6 Label");
ObjectDelete("H6 Line");
ObjectDelete("H5 Label");
ObjectDelete("H5 Line");
ObjectDelete("H24 Label");
ObjectDelete("H24 Line");
ObjectDelete("H3 Label");
ObjectDelete("H3 Line");
ObjectDelete("H2 Label");
ObjectDelete("H2 Line");
ObjectDelete("H1 Label");
ObjectDelete("H1 Line");
ObjectDelete("L1 Label");
ObjectDelete("L1 Line");
ObjectDelete("L2 Label");
ObjectDelete("L2 Line");
ObjectDelete("L3 Label");
ObjectDelete("L3 Line");
ObjectDelete("L4 Label");
ObjectDelete("L4 Line");
ObjectDelete("L5 Label");
ObjectDelete("L5 Line");
ObjectDelete("L6 Label");
ObjectDelete("L6 Line");
ObjectDelete("L7 Lable");
ObjectDelete("L7 Line");
ObjectDelete("L8 Lable");
ObjectDelete("L8 Line");

ObjectDelete("L Label");
ObjectDelete("L Line");


ObjectDelete("FiboUp2");
   ObjectDelete("FiboDn2");
   ObjectDelete("FiboIn2");
   ObjectDelete("FiboUp");
   ObjectDelete("FiboDn");
   ObjectDelete("FiboIn");
   return(0);
}


//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+

int DrawFibo()
{if(Fibolines){
	if(ObjectFind("FiboUp") == -1)
		ObjectCreate("FiboUp",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("FiboUp",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboUp",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboUp",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("FiboUp",OBJPROP_PRICE2,HiPrice);
	}
   ObjectSet("FiboUp",OBJPROP_COLOR,UpColor);
   ObjectSet("FiboUp",OBJPROP_FIBOLEVELS,7);
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboUp",0,"100.0  %$"); 
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboUp",1,"123.6  %$"); 
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboUp",2,"SHORT***138.2  %$"); 
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboUp",3,"150.0  %$"); 
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboUp",4,"SHORT***161.8  %$"); 
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboUp",5,"176.4  %$"); 
   ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboUp",6,"STOP 50 PIPS 200.0  %$"); 
   ObjectSet("FiboUp",OBJPROP_RAY,true);
   ObjectSet("FiboUp",OBJPROP_BACK,true);

	if(ObjectFind("FiboDn") == -1)
		ObjectCreate("FiboDn",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("FiboDn",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboDn",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboDn",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("FiboDn",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("FiboDn",OBJPROP_COLOR,DnColor); 
   ObjectSet("FiboDn",OBJPROP_FIBOLEVELS,7);
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboDn",0,"0.0  %$"); 
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboDn",1,"-23.6  %$"); 
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboDn",2,"LONGllll***-38.2  %$"); 
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboDn",3,"-50.0  %$"); 
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboDn",4,"LONG***-61.8  %$"); 
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboDn",5,"-76.4  %$"); 
   ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboDn",6,"STOP 50 PIPS-100.0  %$"); 
   ObjectSet("FiboDn",OBJPROP_RAY,true);
   ObjectSet("FiboDn",OBJPROP_BACK,true);

	if(InnerFibs)
	{
		if(ObjectFind("FiboIn") == -1)
			ObjectCreate("FiboIn",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_D1*60,LoPrice);
		else
		{
			ObjectSet("FiboIn",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboIn",OBJPROP_TIME1, StartTime+PERIOD_D1*60);
			ObjectSet("FiboIn",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboIn",OBJPROP_PRICE2,LoPrice);
		}
   	ObjectSet("FiboIn",OBJPROP_COLOR,InColor); 
   	ObjectSet("FiboIn",OBJPROP_FIBOLEVELS,7);
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboIn",0,"LONG ***(3)0.0  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboIn",1,"23.6  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboIn",2,"38.2  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboIn",3,"50.0  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboIn",4,"61.8  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboIn",5,"76.4  %$"); 
   	ObjectSet("FiboIn",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboIn",6,"TARGET ***(3)100.0  %$"); 
   	ObjectSet("FiboIn",OBJPROP_RAY,true);
   	ObjectSet("FiboIn",OBJPROP_BACK,true);
   }
   else
	   ObjectDelete("FiboIn");
}}
//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+

int start()
{
	int shift	= iBarShift(NULL,PERIOD_D1,Time[0]) + 1;	// yesterday
	HiPrice		= iHigh(NULL,PERIOD_D1,shift);
	LoPrice		= iLow (NULL,PERIOD_D1,shift);
	StartTime	= iTime(NULL,PERIOD_D1,shift);

	if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	{//Add fridays high and low
		HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_D1,shift+1));
		LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_D1,shift+1));
	}

	Range = HiPrice-LoPrice;

	DrawFibo();
	L2=LoPrice;
	L3=	LoPrice-Range ;
		L1=LoPrice-Range*(0.618) ;
	L=LoPrice-Range*(0.382) ;
	H=HiPrice+Range*(0.382) ;
	H1=HiPrice+Range*(0.618);
	H3=HiPrice+Range;
	H2=HiPrice;

   if(ObjectFind("H line") != 0)
      {
      ObjectCreate("H line", OBJ_HLINE, 0, Time[40],  OBJPROP_FIRSTLEVEL+0,0.0);
      ObjectSet("Hline", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H line", OBJPROP_WIDTH, 2);
      ObjectSet("H line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("H line", 0, Time[40], H);
      }
      
     
      
    if(ObjectFind("L line") != 0)
      {
      ObjectCreate("L line", OBJ_HLINE, 0, Time[40],  L);
      ObjectSet("Lline", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L line", OBJPROP_WIDTH, 2);
      ObjectSet("L line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("L line", 0, Time[40], L);
      }
    
    
      
     
      
      
      
    

      if(ObjectFind("H3 line") != 0)
      {
      ObjectCreate("H3 line", OBJ_HLINE, 0, Time[40], H3);
      ObjectSet("H3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H3 line", OBJPROP_WIDTH, 2);
      ObjectSet("H3 line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("H3 line", 0, Time[40], H3);
      }
      
      
      
      if(ObjectFind("H2 line") != 0)
      {
      ObjectCreate("H2 line", OBJ_HLINE, 0, Time[40], H2);
      ObjectSet("H2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H2 line", OBJPROP_WIDTH, 2);
      ObjectSet("H2 line", OBJPROP_COLOR, Magenta);
      }
      else
      {
      ObjectMove("H2 line", 0, Time[40], H2);
      }


      if(ObjectFind("H1 line") != 0)
      {
      ObjectCreate("H1 line", OBJ_HLINE, 0, Time[40], H1);
      ObjectSet("H1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H1 line", OBJPROP_WIDTH, 2);
      ObjectSet("H1 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("H1 line", 0, Time[40], H1);
      }


      if(ObjectFind("L1 line") != 0)
      {
      ObjectCreate("L1 line", OBJ_HLINE, 0, Time[40], L1);
      ObjectSet("L1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L1 line", OBJPROP_WIDTH, 2);
      ObjectSet("L1 line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("L1 line", 0, Time[40], L1);
      }


      if(ObjectFind("L2 line") != 0)
      {
      ObjectCreate("L2 line", OBJ_HLINE, 0, Time[40], L2);
      ObjectSet("L2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L2 line", OBJPROP_WIDTH, 2);
      ObjectSet("L2 line", OBJPROP_COLOR, Magenta);
      }
      else
      {
      ObjectMove("L2 line", 0, Time[40], L2);
      }

      if(ObjectFind("L3 line") != 0)
      {
      ObjectCreate("L3 line", OBJ_HLINE, 0, Time[40], L3);
      ObjectSet("L3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L3 line", OBJPROP_WIDTH, 2);
      ObjectSet("L3 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("L3 line", 0, Time[40], L3);
      }


     



      if(ObjectFind("H3 label") != 0)
      {
      ObjectCreate("H3 label", OBJ_TEXT, 0, Time[10], H3);
      ObjectSetText("H3 label", "stop of sell", 9, "Arial", Lime);
      }
      else
      {
      ObjectMove("H3 label", 0, Time[10], H3);
      }


      if(ObjectFind("H2 label") != 0)
      {
      ObjectCreate("H2 label", OBJ_TEXT, 0, Time[10], H2);
      ObjectSetText("H2 label", "target of buy", 9, "Arial", Magenta);
      }
      else
      {
      ObjectMove("H2 label", 0, Time[10], H2);
      }
 if(ObjectFind("H label") != 0)
      {
      ObjectCreate("H label", OBJ_TEXT, 0, Time[10], H);
      ObjectSetText("H label", "sell1", 9, "Arial", Red);
      }
      else
      {
      ObjectMove("H label", 0, Time[10], H);
      }

      if(ObjectFind("H1 label") != 0)
      {
      ObjectCreate("H1 label", OBJ_TEXT, 0, Time[10], H1);
      ObjectSetText("H1 label", "sell2", 9, "Arial", Red);
      }
      else
      {
      ObjectMove("H1 label", 0, Time[10], H1);
      }



      if(ObjectFind("L1 label") != 0)
      {
      ObjectCreate("L1 label", OBJ_TEXT, 0, Time[10], L1);
      ObjectSetText("L1 label", "buy 2", 9, "Arial", Lime);
      }
      else
      {
      ObjectMove("L1 label", 0, Time[10], L1);
      }

 if(ObjectFind("L label") != 0)
      {
      ObjectCreate("L label", OBJ_TEXT, 0, Time[10], L);
      ObjectSetText("L label", "buy 1", 9, "Arial",Lime);
      }
      else
      {
      ObjectMove("L label", 0, Time[10], L);
      }

      if(ObjectFind("L2 label") != 0)
      {
      ObjectCreate("L2 label", OBJ_TEXT, 0, Time[10], L2);
      ObjectSetText("L2 label", "target of sell", 9, "Arial", Magenta);
      }
      else
      {
      ObjectMove("L2 label", 0, Time[10], L2);
      }

      if(ObjectFind("L3 label") != 0)
      {
      ObjectCreate("L3 label", OBJ_TEXT, 0, Time[10], L3);
      ObjectSetText("L3 label", "stop of buy", 9, "Arial", Red);
      }
      else
      {
      ObjectMove("L3 label", 0, Time[10], L3);
      }

     
      
	return(0);
}
//+------------------------------------------------------------------+

