//+------------------------------------------------------------------+
//|                                                          CDP.mq4 |
//|                                                          Kalenzo |
//|                                                  simone@konto.pl |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "simone@konto.pl"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Green
double h1[],h2[],l1[],l2[],CDP;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,h1);
   SetIndexBuffer(1,h2);
   SetIndexBuffer(2,l1);
   SetIndexBuffer(3,l2);
   SetIndexLabel(0,"AnalysisHigh1");
   SetIndexLabel(1,"AnalysisHigh2");
   SetIndexLabel(2,"AnalysisLow1");
   SetIndexLabel(3,"AnalysisLow2");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
//---- 
   /*
   Input
PreviousHigh(PH),PreviousLow(PL),PreviousClose(PC) ,

Output:
CDP=(PH+PL+PC)/3
AnalysisHigh1=CDP+(PH-PL)
AnalysisHigh2=2*CDP-PL
AnalysisLow1=CDP-(PH-PL)
AnalysisLow2=2*CDP-PH

Mark AH1,AH2,AL1,AL2 in chart for reference.
   */
for(int i=counted_bars;i>=0;i--)
{
   CDP = (iHigh(Symbol(),0,i+1) + iLow(Symbol(),0,i+1) + iClose(Symbol(),0,i+1))/3;
   h1[i] = CDP+(iHigh(Symbol(),0,i+1) - iLow(Symbol(),0,i+1));
   h2[i] = 2 * CDP - iLow(Symbol(),0,i+1);
   l1[i] = CDP - (iHigh(Symbol(),0,i+1)-iLow(Symbol(),0,i+1));
   l2[i] = 2 * CDP -iHigh(Symbol(),0,i+1); 
}
//----
   return(0);
  }
//+------------------------------------------------------------------+